module ("basic_stats.analyze", package.seeall)

--- Analyze a binary
-- @param binary a binary to analyze
function basic_stats:analyze (binary)
	local results  = Table:new ()
	local nb_block = 0   -- used to count blocks
	local nb_loop  = 0   -- used to count loops
	local nb_insn  = 0   -- used to count instructions
	
	-- Iterate over functions
	for f in binary:functions () do
	   results[f:get_name ()] = Table:new ()
	   nb_block = 0
	   nb_loop = 0
	   nb_insn  = 0
	   
	   -- Count blocks and instructions
	   for b in f:blocks () do
	      nb_block = nb_block + 1
	   
	      for insn in b:instructions () do
	         nb_insn = nb_insn +1
	      end
	   end
	   
	   -- Count loops
	   for b in f:loops () do
	      nb_loop = nb_loop + 1
	   end
	   
	   -- Save results in the table
	   results[f:get_name ()]["nb_block"] = nb_block
	   results[f:get_name ()]["nb_loop"] = nb_loop
	   results[f:get_name ()]["nb_insn"] = nb_insn
	end

   return results
end
